import * as i0 from '@angular/core';
import { Injectable, Component, ViewChild, HostListener, Input, NgModule } from '@angular/core';

class MbSelectPopupService {
    constructor() { }
    static { this.ɵfac = i0.ɵɵngDeclareFactory({ minVersion: "12.0.0", version: "16.2.12", ngImport: i0, type: MbSelectPopupService, deps: [], target: i0.ɵɵFactoryTarget.Injectable }); }
    static { this.ɵprov = i0.ɵɵngDeclareInjectable({ minVersion: "12.0.0", version: "16.2.12", ngImport: i0, type: MbSelectPopupService, providedIn: 'root' }); }
}
i0.ɵɵngDeclareClassMetadata({ minVersion: "12.0.0", version: "16.2.12", ngImport: i0, type: MbSelectPopupService, decorators: [{
            type: Injectable,
            args: [{
                    providedIn: 'root'
                }]
        }], ctorParameters: function () { return []; } });

class MbSelectPopupComponent {
    static { this.ɵfac = i0.ɵɵngDeclareFactory({ minVersion: "12.0.0", version: "16.2.12", ngImport: i0, type: MbSelectPopupComponent, deps: [], target: i0.ɵɵFactoryTarget.Component }); }
    static { this.ɵcmp = i0.ɵɵngDeclareComponent({ minVersion: "14.0.0", version: "16.2.12", type: MbSelectPopupComponent, selector: "lib-mb-select-popup", ngImport: i0, template: `
    <p>
      mb-select-popup works!
    </p>
  `, isInline: true }); }
}
i0.ɵɵngDeclareClassMetadata({ minVersion: "12.0.0", version: "16.2.12", ngImport: i0, type: MbSelectPopupComponent, decorators: [{
            type: Component,
            args: [{ selector: 'lib-mb-select-popup', template: `
    <p>
      mb-select-popup works!
    </p>
  ` }]
        }] });

class SelectPopupComponent {
    constructor(elRef, renderer) {
        this.elRef = elRef;
        this.renderer = renderer;
        this.selectedText = null;
    }
    ngAfterViewInit() {
        const popup = document.querySelector('.popup');
        if (this.width) {
            popup.style.width = this.width;
        }
        if (this.height) {
            popup.style.height = this.height;
        }
        if (this.bgColor) {
            popup.style.backgroundColor = this.bgColor;
        }
        if (this.fontColor) {
            popup.style.color = this.fontColor;
        }
        if (this.fontSize) {
            popup.style.fontSize = this.fontSize;
        }
    }
    handleClickOutside(event) {
        if (!this.elRef.nativeElement.contains(event.target)) {
            this.hidePopup();
        }
    }
    handleSelection(event) {
        const selection = window.getSelection();
        const selectedText = selection?.toString().trim();
        if (selectedText) {
            this.showPopup(event.clientX, event.clientY, selectedText);
        }
        else {
            this.hidePopup();
        }
    }
    showPopup(x, y, text) {
        this.selectedText = text;
        const popup = document.querySelector('.popup');
        if (popup) {
            const maxX = document.documentElement.scrollWidth - popup.offsetWidth;
            const maxY = document.documentElement.scrollHeight - popup.offsetHeight;
            const adjustedX = Math.min(x, maxX);
            const adjustedY = Math.min(y, maxY);
            popup.style.top = `${adjustedY}px`;
            popup.style.left = `${adjustedX}px`;
            popup.classList.add('active');
        }
        else {
            // console.error('Popup element not found.');
        }
    }
    hidePopup() {
        if (!this.selectedText) {
            return; // No need to hide the popup if there is no selected text
        }
        const popup = document.querySelector('.popup');
        popup.classList.remove('active'); // Remove the active class to hide the popup smoothly
        setTimeout(() => {
            this.selectedText = null;
        }, 300); // Adjust the timeout to match the transition duration
    }
    static { this.ɵfac = i0.ɵɵngDeclareFactory({ minVersion: "12.0.0", version: "16.2.12", ngImport: i0, type: SelectPopupComponent, deps: [{ token: i0.ElementRef }, { token: i0.Renderer2 }], target: i0.ɵɵFactoryTarget.Component }); }
    static { this.ɵcmp = i0.ɵɵngDeclareComponent({ minVersion: "14.0.0", version: "16.2.12", type: SelectPopupComponent, selector: "lib-select-popup", inputs: { width: "width", height: "height", bgColor: "bgColor", fontColor: "fontColor", fontSize: "fontSize" }, host: { listeners: { "document:click": "width($event)" } }, viewQueries: [{ propertyName: "popupElement", first: true, predicate: ["popupElement"], descendants: true }], ngImport: i0, template: "<div (mouseup)=\"handleSelection($event)\">\n    <ng-content></ng-content>\n  </div>\n  \n  <div #popupElement class=\"popup\">\n    <p>{{ selectedText }}</p>\n  </div>\n  ", styles: [".popup{position:absolute;background-color:#fff;color:#000;border:1px solid #ccc;padding:0rem .5rem;box-shadow:0 0 10px #0000001a;opacity:0;transform:scale(.8);transition:opacity .3s ease,transform .3s ease;max-width:300px}.popup.active{opacity:1;transform:scale(1)}\n"] }); }
}
i0.ɵɵngDeclareClassMetadata({ minVersion: "12.0.0", version: "16.2.12", ngImport: i0, type: SelectPopupComponent, decorators: [{
            type: Component,
            args: [{ selector: 'lib-select-popup', template: "<div (mouseup)=\"handleSelection($event)\">\n    <ng-content></ng-content>\n  </div>\n  \n  <div #popupElement class=\"popup\">\n    <p>{{ selectedText }}</p>\n  </div>\n  ", styles: [".popup{position:absolute;background-color:#fff;color:#000;border:1px solid #ccc;padding:0rem .5rem;box-shadow:0 0 10px #0000001a;opacity:0;transform:scale(.8);transition:opacity .3s ease,transform .3s ease;max-width:300px}.popup.active{opacity:1;transform:scale(1)}\n"] }]
        }], ctorParameters: function () { return [{ type: i0.ElementRef }, { type: i0.Renderer2 }]; }, propDecorators: { popupElement: [{
                type: ViewChild,
                args: ['popupElement']
            }], width: [{
                type: HostListener,
                args: ['document:click', ['$event']]
            }, {
                type: Input
            }], height: [{
                type: Input
            }], bgColor: [{
                type: Input
            }], fontColor: [{
                type: Input
            }], fontSize: [{
                type: Input
            }] } });

class MbSelectPopupModule {
    static { this.ɵfac = i0.ɵɵngDeclareFactory({ minVersion: "12.0.0", version: "16.2.12", ngImport: i0, type: MbSelectPopupModule, deps: [], target: i0.ɵɵFactoryTarget.NgModule }); }
    static { this.ɵmod = i0.ɵɵngDeclareNgModule({ minVersion: "14.0.0", version: "16.2.12", ngImport: i0, type: MbSelectPopupModule, declarations: [MbSelectPopupComponent, SelectPopupComponent], exports: [MbSelectPopupComponent, SelectPopupComponent] }); }
    static { this.ɵinj = i0.ɵɵngDeclareInjector({ minVersion: "12.0.0", version: "16.2.12", ngImport: i0, type: MbSelectPopupModule }); }
}
i0.ɵɵngDeclareClassMetadata({ minVersion: "12.0.0", version: "16.2.12", ngImport: i0, type: MbSelectPopupModule, decorators: [{
            type: NgModule,
            args: [{
                    declarations: [MbSelectPopupComponent, SelectPopupComponent],
                    imports: [],
                    exports: [MbSelectPopupComponent, SelectPopupComponent],
                }]
        }] });

/*
 * Public API Surface of mb-select-popup
 */

/**
 * Generated bundle index. Do not edit.
 */

export { MbSelectPopupComponent, MbSelectPopupModule, MbSelectPopupService, SelectPopupComponent };
//# sourceMappingURL=mb-select-popup.mjs.map
